------------------------------------
-----------[[  VIEW  ]]------------
-------visual arc handling----------
----(obeys, doesn't investigate)-----
------------------------------------

------------
---- Globals
--------------------
-- Texture directory
Archimedes.context = UI.CreateContext("Archimedes HUD")
Archimedes.imgdir = "img"

function Archimedes.View()
  Archimedes.side = {}
  Archimedes.side.left = UI.CreateFrame("Frame", "Left Group", Archimedes.context)
  Archimedes.side.left:SetPoint("CENTERRIGHT", UIParent, "CENTER", 0 - Archimedes.Options.globals.spacing, 0)
  Archimedes.side.right = UI.CreateFrame("Frame", "Right Group", Archimedes.context)
  Archimedes.side.right:SetPoint("CENTERLEFT", UIParent, "CENTER", Archimedes.Options.globals.spacing, 0)
  Archimedes.side.right:SetAlpha(Archimedes.Options.globals.alpha)
  Archimedes.side.left:SetAlpha(Archimedes.Options.globals.alpha)
end

function Archimedes.CreateArc(arcid, opt)
  -- Create the arc's UI elements
  local arc = table.remove(Archimedes.zombieArcs)
  if not arc then arc = UI.CreateFrame("Texture", "arc", Archimedes.side[opt.group])
  arc.background = UI.CreateFrame("Texture", "arc", arc)
  arc.mask = UI.CreateFrame("Mask", "mask", arc)
  arc.texture = UI.CreateFrame("Texture", "texture", arc.mask)
  -- Settings that won't change (layers, points etc)
  arc.background:SetLayer(-1)
  arc.background:SetAllPoints(arc)
  arc.mask:SetAllPoints(arc)
  arc.texture:SetAllPoints(arc)
  -- hide for now
  arc:SetVisible(false)

  --Mockup properties
  arc.max = 100
  arc.curr = 100
  arc.fade = nil
  arc.condition = {}
  end

    -- FUNCTIONS

  function arc:FadeOut()
    if not Archimedes.activeArcs[arcid].fade then
    local animation = {
      {0.3},
      {0.5, 1, 0, "sinEaseOut",function(value) self:SetAlpha(value) end},
      {0, 0, 0, "easeNone",function(value) self:SetVisible(false) self:SetAlpha(1) end}
    }
     self.fade = Library.LibAnUI.Animate(animation)
    --self:SetVisible(false)
    end
  end
  -- Reload all (visual) properties from settings
  function arc:ReloadSettings(first)
    self:SetPoint("CENTER", Archimedes.side[opt.group], "CENTER", opt.offsetx, opt.offsety )
    self.background:SetTexture(Archimedes.skins[opt.skinPack].addon, Archimedes.SkinString(opt).background)
    self:SetWidth(self.background:GetTextureWidth() * opt.scale)
    self:SetHeight(self.background:GetTextureHeight() * opt.scale)
    self.texture:SetTexture(Archimedes.skins[opt.skinPack].addon, Archimedes.SkinString(opt).foreground)
    self:SetAlpha(opt.alpha)
    self:SetParent(Archimedes.side[opt.group])
    if not first then self:ForceUpdate() end
    --Archimedes.ArcLoader()
  end
  -- Set new values
  function arc:SetNew(value, what)
  if not value == true then return end
  if not what then what =  "curr" end
    self[what] = value
    self.mask:SetPoint("TOP", self, nil, (self.max - self.curr) / self.max)
  end
  -- Force update the arc to load the data from Inspect.Unit.Detail
  function arc:ForceUpdate()
    -- Just so that they are not empty
    local details = Inspect.Unit.Detail(opt.unit)
    -- If the unit exists...
    if details then
    if details[opt.specifier] then
      --If the value doesn't exist, set it to 100
      self.max = 100
      self.curr = 100
      if not details[opt.specifier .. "Max"] then details[opt.specifier .. "Max"] = 100 end
      if not details[opt.specifier] then details[opt.specifier] = 100 end
      -- Then run the updater
      self:SetNew(details[opt.specifier .. "Max"], "max")
      self:SetNew(details[opt.specifier])
    end
    end
  end

  -- Return the created arc
  arc:ReloadSettings(true)
  return arc
end
