nkWardrobe.Config = { 
	frame = nil,
	icons = { cleric = {}, rogue = {}, warrior = {}, mage = {} },
	EquipSlot = {},
	tooltip = nil,
	errDialog = nil,
	confirmDialog = nil
}

nkWardrobe.Config.riftCategoryToType = { 	['weapon onehand dagger'] = 'onehanded:dagger', ['weapon onehand axe'] = 'onehanded:axe', ['weapon onehand mace'] = 'onehanded:mace', ['weapon onehand sword'] = 'onehanded:sword',
							['weapon ranged bow'] = 'ranged:bow', ['weapon ranged gun'] = 'ranged:gun', ['weapon ranged wand'] = 'ranged:wand', 
							['weapon twohand staff'] = 'twohanded:staff', ['weapon twohand sword'] = 'twohanded:sword', ['weapon twohand hammer'] = 'twohanded:hammer', ['weapon twohand polearm'] = 'twohanded:polearm', ['weapon twohand axe'] = 'twohanded:axe', ['weapon twohand mace'] = 'twohanded:mace', 
							['armor leather head'] = 'helmet:leather', ['armor leather chest'] = 'chest:leather', ['armor leather shoulders'] = 'shoulders:leather', ['armor leather hands'] = 'gloves:leather', ['armor leather waist'] = 'belt:leather', ['armor leather legs'] = 'legs:leather', ['armor leather feet'] = 'feet:leather',
							['armor chain head'] = 'helmet:chain', ['armor chain chest'] = 'chest:chain', ['armor chain shoulders'] = 'shoulders:chain', ['armor chain hands'] = 'gloves:chain', ['armor chain waist'] = 'belt:chain', ['armor chain legs'] = 'legs:chain', ['armor chain feet'] = 'feet:chain',
							['armor plate head'] = 'helmet:plate', ['armor plate chest'] = 'chest:plate', ['armor plate shoulders'] = 'shoulders:plate', ['armor plate hands'] = 'gloves:plate', ['armor plate waist'] = 'belt:plate', ['armor plate legs'] = 'legs:plate', ['armor plate feet'] = 'feet:plate',
							['armor cloth head'] = 'helmet:cloth', ['armor cloth chest'] = 'chest:cloth', ['armor cloth shoulders'] = 'shoulders:cloth', ['armor cloth hands'] = 'gloves:cloth', ['armor cloth waist'] = 'belt:cloth', ['armor cloth legs'] = 'legs:cloth', ['armor cloth feet'] = 'feet:cloth',
							['armor accessory ring'] = 'ring:items', ['armor accessory neck'] = 'neck:items', ['armor accessory trinket'] = 'trinket:items'
						}

nkWardrobe.context = UI.CreateContext("nkWardrobe")
nkWardrobe.context:SetSecureMode('restricted')

function nkWardrobe.Config:new(settings)
	
	local this = settings or {}

	if nkWardrobe.calling == nil then
		local userDetails = Inspect.Unit.Detail ('player')
		nkWardrobe.calling  = userDetails.calling
	end
	
	self:CreateUI()
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkWardrobe.Config:Show(flag) 
	
	self.frame:SetVisible(flag) 
	
end

function nkWardrobe.Config:IsVisible() return self.frame:isVisible() end

function nkWardrobe.Config:Close() 
	
	frame = self.frame.paneTab2
	if frame.fldValueSetName ~= nil then frame.fldValueSetName:leave() end
	
	self:Show(false) 
	
end

function nkWardrobe.Config:CreateUI()

	self.frame = UI.CreateFrame ('nkExtWindow', 'nkWardrobeConfig', nkWardrobe.context, {layer = 1, fontsize = 13, width = 685, height = 490, 
									color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF"},
									title = string.format(nkWardrobeTexts.txtHeader, nkWardrobe.addonName, nkWardrobe.addonVersion),
									anchors = {{from = "CENTER", object = UIParent, to = "CENTER"}}, closeable = true, collapsible = true, dragable = true, visible = true,
									closeFunc = function() nkWardrobe.Config:Close() end})
	
	self.frame:getElement(false):SetSecureMode('restricted')
	self.frame:getElement(true):SetSecureMode('restricted')
	self.frame:getBody(false):SetSecureMode('restricted')
	self.frame:getBody(true):SetSecureMode('restricted')
	
	local btTemplate = { color = {body = "3B5998", border="000000", label = "FFFFFF"}}
	
	self.frame.closeButton = UI.CreateFrame ('nkExtButton', 'nkWardrobeConfigbtClose', self.frame:getBody(true), { layer = 1, label = nkWardrobeTexts.btClose, anchors = {{from = "BOTTOMLEFT", object = self.frame:getBody(true), to = "BOTTOMLEFT", x = 10, y = -10}}, func = function () self:Close() end, template = btTemplate})	
	self.frame.reloadButton = UI.CreateFrame ('nkExtButton', 'nkZooConfigbtReload', self.frame:getBody(true), { layer = 1, label = nkWardrobeTexts.btReload, anchors = {{from = "CENTERLEFT", object = self.frame.closeButton:getElement(), to = "CENTERRIGHT", x = 10, y = 0}}, macro = "reloadui", template = btTemplate})	
	
	self.frame.paneTab2 = UI.CreateFrame ('nkExtFrame', 'nkWardrobeConfigTab1', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
	self.frame.paneTab3 = UI.CreateFrame ('nkExtFrame', 'nkWardrobeConfigTab2', self.frame:getBody(true), { color = {body = "444444"}, visible = false})
		
	self.frame.tabPane = UI.CreateFrame ('nkExtTabPane', 'nkWardrobeConfigTabPane', self.frame:getBody(true), { contentLayer = 3, fontsize = 13, width = 665, height = 409,  color = { body = "444444" , border = "000000" , label= "FFFFFF", inactive = "333333"}, 
											anchors = {{from = "TOPLEFT", object = self.frame:getBody(true), to = "TOPLEFT", x = 10, y = 10}}, 
											panes = {{content = self.frame.paneTab2, label = nkWardrobeTexts.tabHeader2}, {content = self.frame.paneTab3, label = nkWardrobeTexts.tabHeader3, initFunc = function () self:SetupTab3() end}}
										})
	self:SetupTab2()
	
end

function nkWardrobe.Config:SetupTab2()

	local frame = self.frame.paneTab2
	
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })
	
	frame.grid = nkGenie.ExtGrid:new('nkWardrobeSetGrid', frame:getElement(), { fontsize = 13, color = { label = 'FFFFFF', border = '000000', body = '333333', bodyhighlight = 'FFFFFF', labelhighlight = '000000', headerBody = '3B5998', headerLabel = 'ffffff'}, anchors = {{ from = 'TOPLEFT', object = frame:getElement(true), to = "TOPLEFT", x = 10, y = 10}}, clickCallBack = function (colDef) self:editWardrobeSet(colDef) end })
	frame.grid:getElement():SetLayer(1)
	
	frame.grid:layout ({{align = 'left', header = nkWardrobeTexts.gridHeader, width = 250 }}, 5, {})
	self:wardrobeSetListUpdate()
	
	local fldTemplate = { width = 40, height = 20, fontsize = 13, labelwidth = 100, color = { label = 'FFFFFF', border = '000000', body = '333333', focus = '999999'} }

	frame.fldValueSetName = UI.CreateFrame ('nkExtTextField', 'fldValueSetName', frame:getElement(true), { width = 200, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].name, label = nkWardrobeTexts.fldSetName, anchors = {{ from = "TOPLEFT", object = frame.grid:getElement(), to = "TOPRIGHT", x = 20, y = 0 }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].name = value; self:wardrobeSetListUpdate() end , template = fldTemplate})

	local selection = {{ label = string.format(nkWardrobeTexts.txtRole, 1), value = 1}, { label = string.format(nkWardrobeTexts.txtRole, 2), value = 2}, { label = string.format(nkWardrobeTexts.txtRole, 3), value = 3} , { label = string.format(nkWardrobeTexts.txtRole, 4), value = 4 }, { label = string.format(nkWardrobeTexts.txtRole, 5), value = 5 }, { label = string.format(nkWardrobeTexts.txtRole, 6), value = 6 }}
		
	frame.fldSelRoleLabel = UI.CreateFrame('nkExtText', 'fldSelRoleLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldRole, color = 'FFFFFF', anchors = {{ from = "TOPLEFT", object = frame.fldValueSetName.element.label:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }} })
	frame.fldSelRole = UI.CreateFrame('nkExtCombo', 'fldSelRole', frame:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].role, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelRoleLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].role = value end })
	frame.fldSelRole:getElement():SetLayer(4)	
	
	local selection = {}	
	for idx = 1, #nkWardrobeSettings.equipSets, 1 do table.insert (selection, { label = nkWardrobeSettings.equipSets[idx].name, value = idx }) end

	frame.fldSelEquipmentLabel = UI.CreateFrame('nkExtText', 'fldSelEquipmentLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldEquipment, color = 'FFFFFF', anchors = {{ from = "TOPLEFT", object = frame.fldSelRoleLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }} })
	frame.fldSelEquipment = UI.CreateFrame('nkExtCombo', 'fldSelEquipment', frame:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].equipment, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelEquipmentLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].equipment = value end })
	frame.fldSelEquipment:getElement():SetLayer(3)
	
	selection = nkWardrobeTexts.souls[nkWardrobe.calling]
	
	frame.fldSelIconLabel = UI.CreateFrame('nkExtText', 'fldSelIconLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldIcon, color = 'FFFFFF', anchors = {{ from = "TOPLEFT", object = frame.fldSelEquipmentLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }} })
	frame.fldSelIcon = UI.CreateFrame('nkExtCombo', 'fldSelIcon', frame:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelIconLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon = value end })
	frame.fldSelIcon:getElement():SetLayer(2)
	
	local subAnchor = {{ from = "TOPLEFT", object = frame.fldSelIconLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}	
	local sepLinePos = 170
	
	if nkRebuff ~= nil then
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff = -1 end
	
		selection = { { label = nkWardrobeTexts.deactivated, value = -1 }, { label = nkRebuffSettings.setName1, value = 1}, { label = nkRebuffSettings.setName2, value = 2}, { label = nkRebuffSettings.setName3, value = 3},
						{ label = nkRebuffSettings.setName4, value = 4}, { label = nkRebuffSettings.setName5, value = 5}, { label = nkRebuffSettings.setName6, value = 6} }
		
		frame.fldSelRebuffLabel = UI.CreateFrame('nkExtText', 'fldSelRebuffLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldRebuff, color = 'FFFFFF', anchors = subAnchor })
		frame.fldSelRebuff = UI.CreateFrame('nkExtCombo', 'fldSelRebuff', frame:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelRebuffLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff = value end })
		frame.fldSelRebuff:getElement():SetLayer(1)
		
		subAnchor = {{ from = "TOPLEFT", object = frame.fldSelRebuffLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}		
	end
	
	if kAlert ~= nil then
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain = -1 end
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub = -1 end
	
		frame.fldSelKAMainLabel = UI.CreateFrame('nkExtText', 'fldSelKAsetMainLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldKASetMain, color = 'FFFFFF', anchors = subAnchor })
		frame.fldSelKASubLabel = UI.CreateFrame('nkExtText', 'fldSelKASetSubLabel', frame:getElement(), { fontsize = 13, width = 105, text = nkWardrobeTexts.fldKASetSub, color = 'FFFFFF', anchors = {{ from = "TOPLEFT", object = frame.fldSelKAMainLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }} })
								
		selection = { { label = nkWardrobeTexts.deactivated, value = -1 } }
		for idx = 0, 10, 1 do table.insert (selection, { label = string.format(nkWardrobeTexts.kaSet, idx), value = idx} ) end
		
		frame.fldSelKASub = UI.CreateFrame('nkExtCombo', 'fldSelKASub', frame:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelKASubLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub = value end })
		frame.fldSelKASub:getElement():SetLayer(1)
		
		selection = { { label = nkWardrobeTexts.deactivated, value = -1 } }
		for idx = 1, 5, 1 do table.insert (selection, { label = string.format(nkWardrobeTexts.kaSet, idx), value = idx} ) end
		
		frame.fldSelKAMain = UI.CreateFrame('nkExtCombo', 'fldSelKAMain', frame.fldSelKASub:getElement(), { value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain, width = 200, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelKAMainLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain = value end })
		frame.fldSelKAMain:getElement():SetLayer(1)				

		sepLinePos = 200
	end
	
	frame.sepLine = UI.CreateFrame('nkExtFrame', 'sepLine', frame:getElement(), { width = frame:GetWidth(), height = 1, color = { body = '000000'}, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 0, y = sepLinePos }} })
	
	local cbTemplate = {labelinfront = true, labelwidth = 125, fontsize = 13, color = {border = 'FFFFFF', body = '333333' }}
	
	frame.cbButton = UI.CreateFrame('nkExtCheckbox', 'cbButton', frame:getElement(), {text = nkWardrobeTexts.cbButton, checked = nkWardrobeSettings.button, 
														anchors = {{from = "TOPLEFT", object = frame.sepLine:getElement(), to = "BOTTOMLEFT", x= 10, y= 10}}, template = cbTemplate,
														func = function (this) nkWardrobeSettings.button = this:getChecked() end})
	
	frame.slScale = UI.CreateFrame('nkExtSlider', 'slScale', frame:getElement(), {text = string.format(nkWardrobeTexts.slScale, nkWardrobeSettings.scale), value = nkWardrobeSettings.scale, range = {50, 200}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.cbButton:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, labelinfront = true, labelwidth = 125, fontsize = 13, color = {border = 'FFFFFF', body = '333333' },
															func = function(this) nkWardrobeSettings.scale = math.floor(this.value); this:update({ text = string.format(nkWardrobeTexts.slScale, nkWardrobeSettings.scale)}) end })
	
	frame.cbBorder = UI.CreateFrame('nkExtCheckbox', 'cbBorder', frame:getElement(), {text = nkWardrobeTexts.cbBorder, checked = nkWardrobeSettings.border, 
														anchors = {{from = "TOPLEFT", object = frame.slScale:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, template = cbTemplate,
														func = function (this) nkWardrobeSettings.border = this:getChecked() end})
	
	selection = {{ label = nkWardrobeTexts.openTop, value = 'top'}, { label = nkWardrobeTexts.openBottom, value = 'bottom'}, { label = nkWardrobeTexts.openLeft, value = 'left'} , { label = nkWardrobeTexts.openRight, value = 'right' } }

	frame.fldSelOpenLabel = UI.CreateFrame('nkExtText', 'fldSelOpenLabel', frame:getElement(), { fontsize = 13, width = 130, text = nkWardrobeTexts.fldOpen, color = 'FFFFFF', anchors = {{ from = "TOPLEFT", object = frame.cbBorder:getElement(), to = "BOTTOMLEFT", x = 0, y = 10 }} })
	frame.fldSelOpen = UI.CreateFrame('nkExtCombo', 'fldSelIcon', frame:getElement(), { value = nkWardrobeSettings.open, width = 100, fontsize = 13, color = {border = '000000', body = '333333', label = 'FFFFFF'}, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelOpenLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.open = value end })
	frame.fldSelOpen:getElement():SetLayer(2)
	
	local btTemplate = { color = {body = "3B5998", border="000000", label = "FFFFFF"}}
												
	frame.newSetButton = UI.CreateFrame ('nkExtButton', 'newSetButton', frame:getElement(true), { label = nkWardrobeTexts.btNewSet, anchors = {{from = "TOPLEFT", object = frame.grid:getElement(), to = "BOTTOMLEFT", x = 0, y = 5}},
											func = function () self:addWardrobeSet() end, template = btTemplate})	
											
	frame.delSetButton = UI.CreateFrame ('nkExtButton', 'tab3DelSetButton', frame:getElement(true), { label = nkWardrobeTexts.btDelSet, anchors = {{from = "TOPRIGHT", object = frame.grid:getElement(), to = "BOTTOMRIGHT", x = 0, y = 5}},
											func = function () self:removeWardrobeSet() end, template = btTemplate})	
	
end

function nkWardrobe.Config:SetupTab3()

	local frame = self.frame.paneTab3
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })

	frame.addonNameShadow = UI.CreateFrame ('nkExtText', 'addonNameShadow', frame:getElement(), { layer = 1, text = string.format(nkWardrobeTexts.about.addonName, nkWardrobe.addonName), fontsize = 30, color = '000000', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 2, y = 12 }} })
	frame.addonName = UI.CreateFrame ('nkExtText', 'addonName', frame:getElement(), { layer = 2, text = string.format(nkWardrobeTexts.about.addonName, nkWardrobe.addonName), fontsize = 30, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 0, y = 10 }} })
	
	frame.versionShadow = UI.CreateFrame ('nkExtText', 'versionShadow', frame:getElement(), { layer = 1, text = string.format(nkWardrobeTexts.about.version, nkWardrobe.addonVersion), fontsize = 18, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.version = UI.CreateFrame ('nkExtText', 'version', frame:getElement(), { layer = 2, text = string.format(nkWardrobeTexts.about.version, nkWardrobe.addonVersion), fontsize = 18, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.writtenBy = UI.CreateFrame ('nkExtText', 'writteBy', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.writtenBy, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.version:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	frame.copyright = UI.CreateFrame ('nkExtText', 'copyright', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.copyright, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.writtenBy:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	
	frame.donate1Shadow = UI.CreateFrame ('nkExtText', 'donate1Shadow', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.donate1, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 2, y = 22 }} })
	frame.donate1 = UI.CreateFrame ('nkExtText', 'donate1', frame:getElement(), { layer = 2, text = nkWardrobeTexts.about.donate1, fontsize = 20, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 0, y = 20 }} })
	
	frame.donate2Shadow = UI.CreateFrame ('nkExtText', 'donate2Shadow', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.donate2, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.donate2 = UI.CreateFrame ('nkExtText', 'donate2', frame:getElement(), { layer = 2, text = nkWardrobeTexts.about.donate2, fontsize = 20, color = '008DF2', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.twitter = UI.CreateFrame ('nkExtText', 'twitter', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.twitter, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.donate2:getElement(), to = "BOTTOMCENTER", x = 0, y = 20 }} })		
	frame.blog = UI.CreateFrame ('nkExtText', 'blog', frame:getElement(), { layer = 1, text = nkWardrobeTexts.about.blog, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.twitter:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })		
	
end

function nkWardrobe.Config:editWardrobeSet(row)

	local frame = self.frame.paneTab2
	local grid = frame.grid	
	if grid.values[grid.counter+row-1] == nil then return end
	local name = grid.values[grid.counter + row - 1][1]
	
	for k, v in pairs (nkWardrobeSettings.sets) do
		if v.name == name then 
			nkWardrobeSettings.activeSet = k
			
			frame.fldValueSetName:setValue(v.name)
			
			for l, w in pairs (frame.fldSelRole.selection) do
				if w.value == v.role then 
					frame.fldSelRole:setValue(w.label)
					break
				end
			end
			
			for l, w in pairs (frame.fldSelEquipment.selection) do
				if w.value == v.equipment then 
					frame.fldSelEquipment:setValue(w.label)
					break
				end
			end
			
			for l, w in pairs (frame.fldSelIcon.selection) do
				if w.value == v.icon then 
					frame.fldSelIcon:setValue(w.label)
					break
				end
			end
			
			if nkRebuff ~= nil then
				frame.fldSelRebuff:setByValue(v.nkrebuff)
			end
			
			if kAlert ~= nil then
				if v.KASub == nil then nkWardrobeSettings.sets[k].KASub = -1 end
				if v.KAMain == nil then nkWardrobeSettings.sets[k].KAMain = -1 end
				
				frame.fldSelKASub:setByValue(v.KASub)
				frame.fldSelKAMain:setByValue(v.KAMain)
			end
			
			break
		end
	end
	

end

function nkWardrobe.Config:wardrobeSetListUpdate()

	local frame = self.frame.paneTab2
	local equipmentSets = {}
	
	for k, v in pairs (nkWardrobeSettings.sets) do
		table.insert (equipmentSets, {v.name})
	end
	
	--frame.grid.value = equipmentSets[1]
	frame.grid:fill (equipmentSets)

end

function nkWardrobe.Config:addWardrobeSet()

	local counter = #nkWardrobeSettings.sets + 1
	table.insert (nkWardrobeSettings.sets, {name = string.format(nkWardrobeTexts.set, counter), role = 1, equipment = 1, nkrebuff = 1, icon = 1, KAMain = -1, KASub = -1 } )
	self:wardrobeSetListUpdate()
end

function nkWardrobe.Config:removeWardrobeSet()

	if #nkWardrobeSettings.sets == 1 then 
		self:errorMessage(nkWardrobeTexts.errLastSet)
	else
		local funcYes = function ()
			local frame = self.frame.paneTab2
			local grid = frame.grid	
			local name = frame.fldValueSetName:getValue()
			
			if #nkWardrobeSettings.sets <= 1 then return end
			
			for k, v in pairs (nkWardrobeSettings.sets) do
				if v.name == name then 
					table.remove (	nkWardrobeSettings.sets, k)
					break
				end
			end
			
			self:editWardrobeSet (1)
			self:wardrobeSetListUpdate()
		end
	
		if self.confirmDialog == nil then
			self.confirmDialog = UI.CreateFrame('nkExtDialog', 'nkWardrobeConfirmDialog', nkWardrobe.context, { layer = 2, width = 300, height = 125, confirmButton = true, color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", message = 'FFFFFF'}, 
																											title = string.format(nkWardrobeTexts.txtHeader, nkWardrobe.addonName, nkWardrobe.addonVersion), message = nkWardrobeTexts.msgRemoveSetConfirm, 
																											anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
		else
			self.confirmDialog:update ({ message = nkWardrobeTexts.msgRemoveSetConfirm, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
			self.confirmDialog:SetVisible(true)
		end
	end

end

function nkWardrobe.Config:convertRiftStats(riftItemData)

	local tempItem = {}

	tempItem.type = nkWardrobe.Config.riftCategoryToType[riftItemData.category]
	
	tempItem.de = riftItemData.name		
	tempItem.fr = riftItemData.name
	tempItem.en = riftItemData.name
	
	if riftItemData.damageDelay ~= nil then
		tempItem.dps = math.floor ((riftItemData.damageMax + riftItemData.damageMin) / 2 / riftItemData.damageDelay * 10 ) / 10
	end
	
	if riftItemData.rarity == nil then
		tempItem.q = 0
	elseif riftItemData.rarity == 'uncommon' then
		tempItem.q = 1
	elseif riftItemData.rarity == 'rare' then
		tempItem.q = 2
	elseif riftItemData.rarity == 'epic' then
		tempItem.q = 3
	elseif riftItemData.rarity == 'relic' then
		tempItem.q = 4
	end	
	
	if riftItemData.stats ~= nil then
		tempItem.armor = riftItemData.stats.armor
		
		tempItem.endu = riftItemData.stats.endurance
		tempItem.dex = riftItemData.stats.dexterity
		tempItem.str = riftItemData.stats.strength
		tempItem.dodge = riftItemData.stats.dodge
		tempItem.parry = riftItemData.stats.parry
		tempItem.hit = riftItemData.stats.hit
		tempItem.atp = riftItemData.stats.powerAttack
		tempItem.crit = riftItemData.stats.critAttack
		tempItem.int = riftItemData.stats.intelligence
		tempItem.sp = riftItemData.stats.powerSpell
		tempItem.scrit = riftItemData.stats.critSpell
		tempItem.wis = riftItemData.stats.wisdom
		tempItem.focus = riftItemData.stats.focus
		tempItem.block = riftItemData.stats.block		
		tempItem.tough = riftItemData.stats.toughness

	end
	
	return tempItem

end